# Finite Differences

## Driver

* main.cpp: 
  * ...
  * `std::vector<double*> X={&S_0,&K,&r,&v_0,&T,&rho,&kappa,&theta,&xi};`
  * `for (const auto& x:X) {`
    * `srand(0);`
    * `double eps=std::numeric_limits<double>::epsilon();`
    * `double x_save=*x;`
    * `double h= (*x==0) ? sqrt(eps) : sqrt(eps)*fabs(*x);`
    * `*x=*x+h;`
    * `... // primal`
    * `std::cout << "d Option Price / d x: " << (option_price_p-option_price)/h << std::endl;`
    * `*x=x_save;`
  * `}`
  * ...

## Result

* Option Price: 6.75932
* d Option Price / d x: 0.691955
* d Option Price / d x: -0.624362
* d Option Price / d x: 62.3671
* d Option Price / d x: 21.1417
* d Option Price / d x: 4.64711
* d Option Price / d x: -0.499878
* d Option Price / d x: 0.0568327
* d Option Price / d x: 109.002
* d Option Price / d x: 0.0296423

## Performance

* Elapsed (wall clock) time (h:mm:ss or m:ss): 0:06.83
* Maximum resident set size (kbytes): 4092
