# Scalar Tangent AD with dco/c++

## Preprocessing

* `#include "dco_type.h"`
* globally search and replace `double` with `dco_type<double>`
* heston_mc.cpp, payoff.cpp: `using namespace std;` to facilitate overloading of `std::max` outside of standard namespace

## Driver

* main.cpp: 
  * ...
  * `std::vector<dco_type<double>*> X={&S_0,&K,&r,&v_0,&T,&rho,&kappa,&theta,&xi};`
  * `for (const auto& x:X) { ...`
    * `dco::derivative(*x)=1;`
    * `... // primal`
    * `std::cout << "d Option Price / d x: " << dco::derivative(option_price);`
    * `dco::derivative(*x)=0;`
  * `... }`
  * ...

## Result

* Option Price: 6.75932
* d Option Price / d x: 0.691955
* Option Price: 6.70593
* d Option Price / d x: -0.62504
* Option Price: 6.64052
* d Option Price / d x: 62.3671
* Option Price: 6.68168
* d Option Price / d x: 19.8127
* Option Price: 6.93292
* d Option Price / d x: 4.63735
* Option Price: 6.76777
* d Option Price / d x: -0.0438532
* Option Price: 6.88725
* d Option Price / d x: 0.107649
* Option Price: 6.75787
* d Option Price / d x: 117.882
* Option Price: 6.87034
* d Option Price / d x: -0.409583

## Performance

* Elapsed (wall clock) time (h:mm:ss or m:ss): 0:09.50
* Maximum resident set size (kbytes): 4064

