# Vector Tangent AD with dco/c++

## dco_type.h

* `#pragma once`
* `#include "dco.hpp"`
* `template<typename dco_base_type, int N=9>
using dco_mode=dco::gt1v<dco_base_type,N>;`
* `template<typename dco_base_type>
using dco_type=typename dco_mode<dco_base_type>::type;`

## Preprocessing

* `#include "dco_type.h"`
* globally search and replace `double` with `dco_type<double>`
* heston_mc.cpp, payoff.cpp: `using namespace std;` to facilitate overloading of `std::max` outside of standard namespace

## Driver

* main.cpp: 
  *  ...
  * `std::vector<dco_type<double>*> X={&S_0,&K,&r,&v_0,&T,&rho,&kappa,&theta,&xi};`
  * `for (size_t i=0;i<X.size();i++) dco::derivative(*X[i])[i]=1;`
  *  ...
  * `for (size_t i=0;i<X.size();i++)
    std::cout << dco::derivative(option_price)[i] << ' ';`
  *  ...

## Result

* Option Price: 6.75932
* d Option Price: / d X: 0.691955 -0.624362 62.367 21.1417 4.64715 -0.500163 0.0568204 109.002 0.0296506

## Performance

* Elapsed (wall clock) time (h:mm:ss or m:ss): 0:03.08
* Maximum resident set size (kbytes): 4220
