#include <cmath>
#include <iostream>

template<typename T>
void newton(T& x, const T& p, const T& eps) {
  do { // perform at least one iteration to fix data dependence
    x=x-(x*x-p)/(2*x);
  } while (fabs(x*x-p)>eps); 
}

int main() {
  using T=double;
  T p=2, x=10;
  const T eps=1e-12;
  x=pow(x,2);
  newton(x,p,eps);
  x=exp(-x);
  std::cout << "x=" << x << std::endl;
  return 0;
}

