#include<cmath>
#include<stack>
#include<iostream>

template<typename T>
void newton(T& x, const T& p, const T& eps) {
  do { x=x-(x*x-p)/(2*x); } while (fabs(x*x-p)>eps);
}

template<typename T>
void newton_a(T &x_v, T &x_a, const T &p_v, T &p_a) {
  p_a+=x_a/(2*x_v); 
  x_a=x_a-(2*x_v/(2*x_v)-(x_v*x_v-p_v)/(4*x_v*x_v))*x_a; 
}

int main() {
  using T=double;
  T p_v=2, x_v=10, p_a=0, x_a=1;
  const T eps=1e-12;
  std::stack<T> tbr_T;
  tbr_T.push(x_v);
  x_v=pow(x_v,2);
  newton(x_v,p_v,eps);
  tbr_T.push(x_v);
  x_v=exp(-x_v);
  std::cout << "x=" << x_v << std::endl;
  x_a=-x_v*x_a;
  x_v=tbr_T.top(); tbr_T.pop();
  newton_a(x_v,x_a,p_v,p_a);
  x_v=tbr_T.top(); tbr_T.pop();
  x_a=2*x_v*x_a;
  std::cout << "dxdp=" << p_a << std::endl;
  // std::cout << "dxdx0=" << x_a << std::endl; // vanishes
  return 0;
}

