#include <iostream>
#include <cmath>

template<typename T>
void newton(T& x, const T& p, const T& eps) {
  do {
    x=x-(x*x-p)/(2*x);
  } while (fabs(x*x-p)>eps); 
}

template<typename T>
void tangent_newton(const T& x_v, T& x_t, const T& p_t) {
  x_t=p_t/(2*x_v);
}

int main() {
  using T=double;
  T p_v=2, x_v=10, p_t=1, x_t=0;
  const T eps=1e-12;
  x_t=2*x_v*x_t; x_v=pow(x_v,2);
  newton(x_v,p_v,eps);
  tangent_newton(x_v,x_t,p_t);
  x_v=exp(-x_v); x_t=-x_v*x_t;
  std::cout << "x=" << x_v << std::endl;
  std::cout << "dxdp=" << x_t << std::endl;
  return 0;
}

