// naumann@stce.rwth-aachen.de
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  cout << "1: " << dco::size_of(AM::global_tape) << endl;
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  cout << "2: " << dco::size_of(AM::global_tape) << endl;
  AM::tape_t::position_t pos=AM::global_tape->get_position(); 
  vg=g(x,vh); 
  cout << "3: " << dco::size_of(AM::global_tape) << endl;
  dco::derivative(vg)=1; // seed known \bar{G}
  AM::global_tape->interpret_adjoint_to(pos); 
  cout << "4: " << dco::size_of(AM::global_tape)-8 << endl;
  AM::global_tape->reset_to(pos); 
  double pvg=dco::value(vg); 
  cout << "5: " << dco::size_of(AM::global_tape)-8 << endl;
  y=f(x,vh,pvg); 
  cout << "6: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(y)=1; // seed given \bar{Y}
  AM::global_tape->interpret_adjoint(); 
  cout << "7: " << dco::size_of(AM::global_tape)-8 << endl;
  cout << dco::value(y) << ' ' << dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape); 
  return 0;
}
