// Uwe.Naumann@nag.com
#include <cmath>
#include <iostream>
using namespace std;

template<typename T>
void th(const T& x, const T& tx, T& h_, T& th_) {
  h_=pow(x,2); th_=2*x*tx;
}

template<typename T>
void tg(const T& x, const T& tx, const T& h, const T& th, T& g_, T& tg_) { 
  T v=x*h; T tv=tx*h+x*th; 
  g_=sin(v); tg_=cos(v)*tv; 
}

template<typename T, typename Tg>
void tf(const T& x, const T& tx, const T& h, const T& th, const Tg& g, const T& tg, T& y, T& ty) {
  y=x+h+g; ty=tx+th+tg;
}

template<typename T>
void tF(const T& x, const T& tx, T& y, T& ty) {
  T h_,th_; th(x,tx,h_,th_);
  T g_,tg_; tg(x,tx,h_,th_,g_,tg_);
  tf(x,tx,h_,th_,g_,tg_,y,ty);
}

int main() {
  double x=1.5, tx=1, y, ty;
  tF(x,tx,y,ty);
  cout << y << ' ' << ty << endl;
  return 0;
}
